<template>
  <div class="row top-position justify-content-center img-white-bg">
    <div class="col-11 s-projecct row">
      <div class="col-3 row">
        <div class="col-12 c-project space-1 card card-defult scrollbar">
          <h4 class="t-color-red text-center t-bold">{{getProject.projectTitle}}</h4>
          <div class="c-project-detail scrollbar">
            <p
              class="t-color-soft-gray"
            >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{getProject.projectDetail}}</p>
          </div>
          <div class="row c-project-subdetail">
            <div class="col-12 row">
              <h6 class="t-color-red t-bold col-6">Start</h6>
              <h6 class="col-6 t-right t-color-soft-gray">{{getProject.start}}</h6>
              <h6 class="t-color-red t-bold col-6">End</h6>
              <h6 class="col-6 t-right t-color-soft-gray">{{getProject.end}}</h6>
              <h6 class="t-color-red t-bold col-6">Project Manager</h6>
              <h6 class="col-6 t-right t-color-soft-gray">{{getProject.createBy}}</h6>
              <h6 class="t-color-red t-bold col-6">Total task</h6>
              <h6 class="col-6 t-right t-color-soft-gray">{{getProject.countTask}}</h6>
            </div>
          </div>
          <i
            class="fa fa-cog s-settin  g"
            style="position:absolute; outline:none;"
            @click="getEditProjectData($route.params.id)"
          />
        </div>
        <div class="col-12 c-project space-1 card card-defult">
          <h4 class="t-color-red text-center t-bold">Team Project</h4>
          <div class="c-project-member scrollbar">
            <h6 class="t-color-red t-bold">Project Manager</h6>
            <div class="row">
              <div v-for="getTeamMember in getProjectMembers.team_project" v-bind:key="getTeamMember">
                <div v-if="(getTeamMember.pivot.position === 'project manager') && (getTeamMember.softDelete === 'N')">
                  <div style="margin-bottom:8px">
                    <div v-b-modal.view-member @click="getMemberDetailData(getTeamMember.pivot.user_id, getTeamMember.pivot)" class="t-color-red tag-member">{{getTeamMember.username}}</div>
                  </div>
                </div>
              </div>
            </div>
            <h6 class="t-color-red t-bold">Member</h6>
            <div class="row">
              <div
                v-for="getTeamMember in getProjectMembers.team_project"
                v-bind:key="getTeamMember"
              >
                <div v-if="(getTeamMember.pivot.position !== 'project manager') && (getTeamMember.softDelete === 'N')">
                  <div style="margin-bottom:8px">
                    <div  v-b-modal.view-member @click="getMemberDetailData(getTeamMember.pivot.user_id, getTeamMember.pivot)" class="t-color-red tag-member">{{getTeamMember.username}}</div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <i
            class="fa fa-plus s-add"
            style="position:absolute; outline:none;"
            @click="displayInviteMember()"
          />
        </div>
      </div>
      <div class="col-6 row">
        <div class="col-12 c-project-date space-1 card card-defult"></div>
      </div>
      <div class="col-3 row">
        <div class="col-12 c-project space-1 card card-defult">
          <h4 class="t-color-red text-center t-bold">Self Tasks</h4>
          <div class="c-project-selftask scrollbar">
            <div
              class="row cursor-pointer task-outline"
              v-b-modal.edit
              v-for="getSelfTask in getSelfTasks"
              v-bind:key="getSelfTask"
            >
              <p class="col-10 t-color-soft-gray rem-margin" @click="getViewTaskData(getSelfTask.id)">{{getSelfTask.taskTitle}}</p>
              <div class="col-2">
                <i class="fa fa-cog b-edit" @click="getEditTaskData(getSelfTask.id)" />
                <i
                  class="fa fa-remove b-remove"
                  @click="getDeleteTaskData(getSelfTask.id)"
                  v-b-modal.delete-task
                />
              </div>
            </div>
          </div>
          <i class="fa fa-plus s-add" style="position:absolute; outline:none;" @click="displayAddTask()" />
        </div>
        <div class="col-12 c-project space-1 card card-defult">
          <h4 class="t-color-red text-center t-bold">All Tasks</h4>
          <div class="c-project-selftask scrollbar">
            <div
              class="row cursor-pointer task-outline"
              v-b-modal.edit
              v-for="getTask in getTasks"
              v-bind:key="getTask"
            >
              <p
                class="col-12 t-color-soft-gray rem-margin"
              >{{getTask.taskTitle}}-{{getTask.responsible_person}}</p>
            </div>
          </div>
          <i class="fa fa-plus s-add" style="position:absolute; outline:none;" v-b-modal.edit />
        </div>
      </div>
    </div>
<!-- edit project -->
    <b-modal
      ref="modal-edit-project"
      id="edit-project"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Edit Project</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input type="text" v-model="editProject.projectTitle" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Title</label>
                <h6
                  v-if="editProject.projectTitle.length < 1"
                  class="t-validate t-color-red"
                >
                  <i class="fa fa-exclamation-circle" /> Project title is required
                </h6>
              </div>
              <div class="group">
                <textarea
                  type="textarea"
                  class="scrollbar"
                  rows="5"
                  v-model="editProject.projectDetail"
                  required="required"
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Detail</label>
                <h6
                  v-if="editProject.projectDetail.length < 1"
                  class="t-validate t-color-red"
                >
                  <i class="fa fa-exclamation-circle" /> Project detail is required
                </h6>
              </div>
              <div class="row">
                <div class="col-6">
                  <input type="date" v-model="editProject.start" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>Start</label>
                  <h6
                    v-if="editProject.start === ''"
                    class="t-validate t-color-red"
                  >
                    <i class="fa fa-exclamation-circle" /> Date to end is required
                  </h6>
                </div>
                <div class="col-6">
                  <input type="date" v-model="editProject.end" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>End</label>
                  <h6
                    v-if="editProject.end === ''"
                    class="t-validate t-color-red"
                  >
                    <i class="fa fa-exclamation-circle" /> Date to end end is required
                  </h6>
                </div>
              </div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="updateProjectData"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- invite member -->
    <b-modal
      ref="modal-invite"
      id="invite-member"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Invite Member</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8 row">
              <div class="group col-6" align="center">
                <input
                  type="text"
                  ref="email"
                  v-model="getInvite.email"
                  required="required"
                  v-once
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Email</label>
                <div class="row absolute">
                  <h6 v-if="getInvite.email === '' " class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Email is required
                  </h6>
                  <h6
                    v-if="(getInvite.email !=='') && (!reg.test(getInvite.email))"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" /> Please Enter Correct Email
                  </h6>
                  <h6
                    v-if="(getInvite.email !=='') && (reg.test(getInvite.email))"
                    class="t-validate-div t-color-green col-12 right"
                  >
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group col-6" align="center">
                <input
                  type="text"
                  ref="position"
                  v-model="getInvite.position"
                  required="required"
                  v-once
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Position</label>
                <div class="row absolute">
                  <h6 v-if="getInvite.position === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Position is required
                  </h6>
                  <h6 v-if="getInvite.position !== ''" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="col-12">
                <p class="t-color-soft-gray" align="center">After finish this process.<br>
                  The program will send email to</p><p v-if="getInvite.email === ''" class="t-color-red" align="center">Example@email.com</p>
                  <p v-if="getInvite.email !== ''" class="t-color-red" align="center">{{getInvite.email}}</p>
              </div>
            </div>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="addMemberData"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- view task -->
    <b-modal
      ref="modal-view-task"
      id="view-task"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
    >
      <div class="row">
        <div class="col-12">
          <h2 class="t-color-red" align="center">{{getTask.taskTitle}}</h2>
          <hr />
          <p class="absolute t-right t-last-update">last update - {{getTask.updated_at}}</p>
        </div>
        <div class="col-12 row">
          <div class="col-2" />
          <div class="col-8 row">
            <h5 class="t-color-red col-12">Task Detail</h5>
            <div class="c-project-detail-modal scrollbar col-12">
            <p
              class="t-color-soft-gray"
            >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{getTask.taskDetail}}</p>
          </div>
          <h5 class="t-color-red col-12">Period</h5>
          from {{getTask.start}} to {{getTask.end}}
          <div class="space-1" />
          </div>
        </div>
      </div>
      <button
        size="sm"
        v-on:click="addTaskData"
        class="btn btn-delete position-back-in-modal"
        @click="hideModal()"
      >
        <i class="fa fa-arrow-left" style="font-size:1.5rem;"></i>
      </button>
      <div class="sub-menubar-2">
        <i id="setting-icon" class="fa fa-pencil-square-o b-sub-1" style="position:absolute; outline:none;" @click="getEditTaskData(getTask.id)" />
        <i id="destroy-icon" class="fa fa-trash b-sub-2" style="position:absolute; outline:none;" @click="getDeleteTaskData(getTask.id)" v-b-modal.delete-task/>
      </div>
      <b-tooltip target="setting-icon" placement="left">Edit</b-tooltip>
      <b-tooltip target="destroy-icon" placement="left">Destroy</b-tooltip>
    </b-modal>
<!-- add task -->
    <b-modal
      ref="modal-add-task"
      id="add-task"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Create Your New Task</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input
                  type="text"
                  ref="projectTitle"
                  v-model="addTask.taskTitle"
                  required="required"
                  v-once
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Task Title</label>
                <div class="row absolute">
                  <h6 v-if="addTask.taskTitle.length < 1" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Task title is required
                  </h6>
                  <h6 v-if="addTask.taskTitle.length > 0" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group">
                <textarea
                  type="textarea"
                  ref="projectDetail"
                  class="scrollbar"
                  rows="3"
                  v-model="addTask.taskDetail"
                  required="required"
                  v-once
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Task Detail</label>
                <div class="row absolute">
                  <h6 v-if="addTask.taskDetail.length < 1" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Task detail is required
                  </h6>
                  <h6 v-if="addTask.taskDetail.length > 0" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="row">
                <div class="col-6">
                  <input type="date" ref="start" v-model="addTask.start" required="required" v-once />
                  <span class="bar" placeholder="false"></span>
                  <label>Start</label>
                  <div class="row absolute">
                    <h6 v-if="addTask.start === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Date to strat is required
                    </h6>
                    <h6 v-if="addTask.start !== ''" class="t-validate-div t-color-green col-12 right">
                      <i class="fa fa-check-circle" /> Correct
                    </h6>
                  </div>
                </div>
                <div class="col-6">
                  <input type="date" ref="end" v-model="addTask.end" required="required" v-once />
                  <span class="bar" placeholder="false"></span>
                  <label>End</label>
                  <div class="row absolute">
                    <h6 v-if="addTask.end === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Date to end is required
                    </h6>
                    <h6 v-if="addTask.end !== ''" class="t-validate-div t-color-green col-12 right">
                      <i class="fa fa-check-circle" /> Correct
                    </h6>
                  </div>
                </div>
              </div>
              <!-- <div class="group">
                <label>Responsible Person</label>
                <b-form-select
                  class="scrollbar"
                  v-model="addTask.responsible_person"
                  :options="options"
                  :select-size="5"
                  style="margin-top: 36px; max-width: 32vw;"
                ></b-form-select>
                <div class="row absolute">
                  <h6 v-if="addTask.responsible_person === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Date to end is required
                  </h6>
                  <h6 v-if="addTask.responsible_person !== ''" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div> -->
              <div class="space-1"/>
              <div class="t-color-soft-gray user-select-non"><i class="fa fa-exclamation-circle" /> After creating, the task will set yourself to a responsible person.</div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="addTaskData"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- edit task -->
    <b-modal
      ref="modal-edit-task"
      id="edit-task"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Edit Task</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input type="text" v-model="getEditTask.taskTitle" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Task Title</label>
                <div class="row absolute">
                  <h6 v-if="getEditTask.taskTitle.length < 1" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Task title is required
                  </h6>
                  <h6 v-if="getEditTask.taskTitle.length > 0" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group">
                <textarea
                  type="textarea"
                  class="scrollbar"
                  rows="5"
                  v-model="getEditTask.taskDetail"
                  required="required"
                />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Task Detail</label>
                <div class="row absolute">
                  <h6 v-if="getEditTask.taskDetail.length < 1" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Task detail is required
                  </h6>
                  <h6 v-if="getEditTask.taskDetail.length > 0" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="row">
                <div class="col-6">
                  <input type="date" v-model="getEditTask.start" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>Start</label>
                  <div class="row absolute">
                    <h6 v-if="getEditTask.start === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Date to start is required
                    </h6>
                    <h6 v-if="getEditTask.start !== ''" class="t-validate-div t-color-green col-12 right">
                      <i class="fa fa-check-circle" /> Correct
                    </h6>
                  </div>
                </div>
                <div class="col-6">
                  <input type="date" v-model="getEditTask.end" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>End</label>
                  <div class="row absolute">
                    <h6 v-if="getEditTask.end === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Date to end is required
                    </h6>
                    <h6 v-if="getEditTask.end !== ''" class="t-validate-div t-color-green col-12 right">
                      <i class="fa fa-check-circle" /> Correct
                    </h6>
                  </div>
                </div>
              </div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="updateTask"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- delete task -->
    <b-modal
      ref="modal"
      id="delete-task"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <h2 class="t-color-red" align="center">Delete Task</h2>
      <hr />
      <div class="space-1" />
      <h4 class="t-color-red" align="center">Are You sure?</h4>
      <div class="space-1" />
      <h6 class="t-color-soft-gray" align="center">Do you really want to delete this task.</h6>
      <hr />
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">cancel</button>
      <button
        size="sm"
        v-on:click="deleteTaskData"
        class="btn btn-delete t-uppercase f-right"
        @click="hide()"
      >confirm</button>
    </b-modal>
<!-- view member -->
    <b-modal
      ref="modal-view-member"
      id="view-member"
      size="md"
      hide-footer
      hide-header
      style="position: absolute;"
    >
    <div class="col-12">
      <h2 class="t-color-red" align="center">member</h2>
      <p class="absolute t-right t-last-update">last update - {{getInfo.updated_at}}</p>
      <hr>
    </div>
      <h5>{{getMemberInfo.username}}</h5>
      <h5>position : {{getInfo.position}}</h5>
      <div class="sub-menubar-3">
        <i id="view-icon" class="fa fa-user-circle-o b-sub-1" style="position:absolute; outline:none;" @click="getViewMemberData(getInfo.user_id, getMemberInfo.username)" />
        <i id="setting-icon" class="fa fa-pencil-square-o b-sub-2" style="position:absolute; outline:none;" @click="getEditMemberData(getInfo.user_id)" />
        <i id="leave-icon" class="fa fa-sign-out b-sub-3" style="position:absolute; outline:none;" @click="getDestroyMemberData(getInfo.user_id)" />
      </div>
      <b-tooltip target="setting-icon" placement="left">Edit</b-tooltip>
      <b-tooltip target="leave-icon" placement="left">Remove</b-tooltip>
      <b-tooltip target="view-icon" placement="left">View Profile</b-tooltip>

    </b-modal>
<!-- view member confirm -->
    <b-modal ref="modal-view-member-con" id="view-project" size="md" hide-footer hide-header style="position: absolute;" v-slot:default="{ hide }">
      <h2 class="t-color-red" align="center">User profile</h2><hr><div class="space-1"/>
      <h4 class="t-color-red" align="center"> Visit to {{getViewUser.username}}'s profile</h4><div class="space-1"/>
      <h6 class="t-color-soft-gray" align="center"> Please click button below.</h6>
      <hr>
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">
        cancel
      </button>
      <router-link :to="'/profile-view/' + getViewUser.id" size="sm" v-on:click="deleteProject" class="btn btn-delete t-uppercase f-right" @click="hide()">
        Visit
      </router-link>
    </b-modal>
<!-- edit member -->
    <b-modal
      ref="modal-edit-member"
      id="edit-member"
      size="md"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <h2 class="t-color-red" align="center">edit member</h2>
      <hr />
      <h4 class="t-color-red" align="center">Change position of {{getMemberInfo.username}}</h4>
      <p class="t-color-soft-gray" align="center">FROM</p>
      <h4 class="t-color-red" align="center">{{getInfo.position}}</h4>
      <p class="t-color-soft-gray" align="center">TO</p>
      <form>
        <div class="row">
          <div class="col-3"/>
          <div class="group col-6" align="center">
            <input
              type="text"
              ref="Position"
              v-model="getNewInfo.position"
              required="required"
              v-once
            />
            <span class="highlight"></span>
            <span class="bar"></span>
            <label>New Position</label>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="UpdateMemberData"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- delete member -->
    <b-modal
      ref="modal-delete-member"
      id="delete-member"
      size="md"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <h2 class="t-color-red" align="center">Remove member</h2>
      <hr />
      <div class="space-1" />
      <h4 class="t-color-red" align="center">Are You sure?</h4>
      <div class="space-1" />
      <h6 class="t-color-soft-gray" align="center">Do you really want to remove this user in project.</h6>
      <hr />
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">cancel</button>
      <button
        size="sm"
        v-on:click="destroyMemberData"
        class="btn btn-delete t-uppercase f-right"
        @click="hide()"
      >confirm</button>
    </b-modal>
  </div>
</template>
<script>
export default {
  data () {
    return {
      // about project information
      getProject: [],
      // about team member
      getMemberInfo: [],
      getProjectMembers: [],
      getTeamMember: {
        id: '',
        username: ''
      },
      // about task
      getSelfTasks: [],
      getSelfTask: {
        id: '',
        taskTitle: '',
        taskDetail: '',
        start: '',
        end: '',
        responsible_person: ''
      },
      getTasks: [],
      getTask: {
        id: '',
        taskTitle: '',
        taskDetail: '',
        start: '',
        end: '',
        responsible_person: ''
      },
      modalEdit: {
        id: 'edit-project',
        projectId: ''
      },
      addTask: {
        taskTitle: '',
        taskDetail: '',
        start: '',
        end: '',
        responsible_person: ''
      },
      getEditTask: [],
      // can user all
      getEditId: '',
      getDeleteId: '',
      getNewInfo: [],
      getViewUser: [],
      options: [
        { value: null, text: 'Please select some item' },
        { value: '1', text: 'This is option a' },
        { value: '2', text: 'Default Selected Option b' },
        { value: '3', text: 'This is option c' },
        { value: '4', text: 'This one is disabled', disabled: true },
        { value: '5', text: 'This is option e' },
        { value: '6', text: 'This is option f' }
      ],
      getInfo: [{
        email: '',
        position: ''
      }],
      getInvite: {
        email: '',
        position: ''
      },
      value: ['apple', 'orange'],
      editProject: [],
      reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/
    }
  },
  mounted () {
    if (!this.$cookie.get('token')) {
      this.$router.push('/signin')
    }
    this.getProjectData()
    this.getProjectMemberData()
    this.getSelfTaskData()
    this.getTaskData()
    this.$refs.modal.on('hidden.bs.modal', () => {
      this.$refs.position.value = ''
    })
  },
  methods: {
    // project function
    getProjectData () {
      this.axios
        .get('/api/showProject/' + this.$route.params.id)
        .then(response => {
          this.getProject = response.data
        })
    },
    getEditProjectData (projectId) {
      this.modalEdit.projectId = projectId
      this.axios
        .get('/api/editProject/' + this.modalEdit.projectId)
        .then(response => {
          this.editProject = response.data
          console.log(projectId)
          this.$refs['modal-edit-project'].show()
        })
    },
    updateProjectData: function (e) {
      e.preventDefault()
      this.axios.put('/api/updateProject/' + this.modalEdit.projectId, {
        projectTitle: this.editProject.projectTitle,
        projectDetail: this.editProject.projectDetail,
        start: this.editProject.start,
        end: this.editProject.end
      })
      this.getProjectData()
    },
    // member function
    getProjectMemberData () {
      this.axios
        .get('/api/memberListInProject/' + this.$route.params.id)
        .then(response => {
          this.getProjectMembers = response.data
        })
    },
    getViewMemberData (id, username) {
      this.getViewUser.id = id
      this.getViewUser.username = username
      this.$refs['modal-view-member-con'].show()
    },
    displayInviteMember () {
      this.getInvite.email = ''
      this.getInvite.position = ''
      this.$refs['modal-invite'].show()
    },
    addMemberData: function (e) {
      e.preventDefault()
      this.axios
        .post('/api/inviteMember/' + this.$route.params.id, {
          email: this.getInvite.email,
          position: this.getInvite.position
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.getInfo.email = ''
      this.getInfo.position = ''
      this.getProjectMemberData()
    },
    getMemberDetailData (id, info) {
      this.axios
        .get('/api/showUser/' + id)
        .then(response => {
          this.getMemberInfo = response.data
          this.getInfo = info
        })
    },
    getEditMemberData () {
      this.$refs['modal-edit-member'].show()
    },
    UpdateMemberData: function (e) {
      e.preventDefault()
      this.axios.put('/api/updateMember/' + this.getInfo.id, {
        position: this.getNewInfo.position
      })
      this.getNewInfo.position = null
      this.getProjectMemberData()
      this.getProjectData()
      this.hideModal()
    },
    getDestroyMemberData (id) {
      console.log(id)
      this.getDeleteId = id
      this.$refs['modal-delete-member'].show()
    },
    destroyMemberData: function (e) {
      e.preventDefault()
      this.axios.put('/api/leaveMember/' + this.getDeleteId, {
        pro_id: this.$route.params.id
      })
      this.getProjectMemberData()
      this.hideModal()
    },
    // task fuction
    displayAddTask () {
      this.addTask.taskTitle = ''
      this.addTask.taskDetail = ''
      this.addTask.start = ''
      this.addTask.end = ''
      this.addTask.responsible_person = ''
      this.$refs['modal-add-task'].show()
    },
    getSelfTaskData () {
      this.axios
        .get('/api/selfTaskList/' + this.$route.params.id)
        .then(response => {
          this.getSelfTasks = response.data
          console.log(this.getSelfTasks)
        })
    },
    getTaskData () {
      this.axios
        .get('/api/TaskList/' + this.$route.params.id)
        .then(response => {
          this.getTasks = response.data
        })
    },
    getViewTaskData (id) {
      this.axios.get('/api/showTask/' + id).then(response => {
        this.getTask = response.data
        this.$refs['modal-view-task'].show()
      })
    },
    addTaskData: function (e) {
      e.preventDefault()
      this.axios
        .post('/api/createTask/' + this.$route.params.id, {
          taskTitle: this.addTask.taskTitle,
          taskDetail: this.addTask.taskDetail,
          start: this.addTask.start,
          end: this.addTask.end,
          responsible_person: this.$cookie.get('id')
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.getSelfTaskData()
      this.getProjectData()
      this.getTaskData()
      this.addTask.taskTitle = ''
      this.addTask.taskDetail = ''
      this.addTask.start = ''
      this.addTask.end = ''
      this.addTask.responsible_person = ''
    },
    getEditTaskData (id) {
      this.getEditId = id
      this.axios.get('/api/editTask/' + this.getEditId).then(response => {
        this.getEditTask = response.data
        this.$refs['modal-edit-task'].show()
        console.log(this.getEditTask)
      })
    },
    updateTask: function (e) {
      e.preventDefault()
      this.axios.put('/api/updateTask/' + this.getEditId, {
        taskTitle: this.getEditTask.taskTitle,
        taskDetail: this.getEditTask.taskDetail,
        start: this.getEditTask.start,
        end: this.getEditTask.end,
        responsible_person: this.$cookie.get('id')
      })
      this.getSelfTaskData()
      this.getTaskData()
      this.getViewTaskData()
      this.hideModal()
    },
    getDeleteTaskData (id) {
      this.getDeleteId = id
    },
    deleteTaskData () {
      this.axios.put('/api/destroyTask/' + this.getDeleteId)
      this.getSelfTaskData()
      this.getProjectData()
      this.hideModal()
      this.getTaskData()
    },
    hideModal () {
      this.$refs['modal-view-task'].hide()
      this.$refs['modal-view-member'].hide()
    }
  }
}
</script>
